package org.jeecg.modules.stm.compliane.item.controller;

import java.util.Arrays;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.modules.stm.compliane.item.entity.StComplianeRiskRef;
import org.jeecg.modules.stm.compliane.item.service.IStComplianeRiskRefService;
import org.jeecg.modules.stm.compliane.item.vo.StComplianeRiskRefVo;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;


import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import org.springframework.web.servlet.ModelAndView;
 
 
import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

/**
 * @Description: st_compliane_risk_ref
 * @Author: yzh
 * @Date:   2023-03-30
 * @Version: V1.0
 */
  
@RestController
@RequestMapping("/compliane.item/stComplianeRiskRef")
@Slf4j
public class StComplianeRiskRefController extends JeecgController<StComplianeRiskRef, IStComplianeRiskRefService> {
	@Autowired
	private IStComplianeRiskRefService stComplianeRiskRefService;
	
	/**
	 * 分页列表查询
	 *
	 * @param stComplianeRiskRef
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "st_compliane_risk_ref-分页列表查询")
	  
	@GetMapping(value = "/list")
	public Result<IPage<StComplianeRiskRef>> queryPageList(StComplianeRiskRef stComplianeRiskRef,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<StComplianeRiskRef> queryWrapper = QueryGenerator.initQueryWrapper(stComplianeRiskRef, req.getParameterMap());
		Page<StComplianeRiskRef> page = new Page<StComplianeRiskRef>(pageNo, pageSize);
		IPage<StComplianeRiskRef> pageList = stComplianeRiskRefService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param stComplianeRiskRef
	 * @return
	 */
	@AutoLog(value = "st_compliane_risk_ref-添加")
	  
	@RequiresPermissions("compliane.item:st_compliane_item:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody StComplianeRiskRefVo stComplianeRiskRef) {
		stComplianeRiskRefService.save(stComplianeRiskRef);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param stComplianeRiskRef
	 * @return
	 */
	@AutoLog(value = "st_compliane_risk_ref-编辑")
	  
	@RequiresPermissions("compliane.item:st_compliane_item:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody StComplianeRiskRef stComplianeRiskRef) {
		stComplianeRiskRefService.updateById(stComplianeRiskRef);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "st_compliane_risk_ref-通过id删除")
	  
	@RequiresPermissions("compliane.item:st_compliane_item:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		stComplianeRiskRefService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "st_compliane_risk_ref-批量删除")
	  
	@RequiresPermissions("compliane.item:st_compliane_item:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.stComplianeRiskRefService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "st_compliane_risk_ref-通过id查询")
	  
	@GetMapping(value = "/queryById")
	public Result<StComplianeRiskRef> queryById(@RequestParam(name="id",required=true) String id) {
		StComplianeRiskRef stComplianeRiskRef = stComplianeRiskRefService.getById(id);
		if(stComplianeRiskRef==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(stComplianeRiskRef);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param stComplianeRiskRef
    */
    @RequiresPermissions("compliane.item:st_compliane_risk_ref:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, StComplianeRiskRef stComplianeRiskRef) {
        return super.exportXls(request, stComplianeRiskRef, StComplianeRiskRef.class, "st_compliane_risk_ref");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("compliane.item:st_compliane_risk_ref:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, StComplianeRiskRef.class);
    }

}
